let allCardImages = [
    'fronts/clubs_2.svg', 'fronts/clubs_3.svg', 'fronts/clubs_4.svg', 'fronts/clubs_5.svg', 'fronts/clubs_6.svg',
    'fronts/clubs_7.svg', 'fronts/clubs_8.svg', 'fronts/clubs_9.svg', 'fronts/clubs_10.svg', 'fronts/clubs_ace.svg',
    'fronts/clubs_jack.svg', 'fronts/clubs_king.svg', 'fronts/clubs_queen.svg', 'fronts/diamonds_2.svg', 'fronts/diamonds_3.svg',
    'fronts/diamonds_4.svg', 'fronts/diamonds_5.svg', 'fronts/diamonds_6.svg', 'fronts/diamonds_7.svg', 'fronts/diamonds_8.svg',
    'fronts/diamonds_9.svg', 'fronts/diamonds_10.svg', 'fronts/diamonds_ace.svg', 'fronts/diamonds_jack.svg', 'fronts/diamonds_king.svg',
    'fronts/diamonds_queen.svg', 'fronts/hearts_2.svg', 'fronts/hearts_3.svg', 'fronts/hearts_4.svg', 'fronts/hearts_5.svg',
    'fronts/hearts_6.svg', 'fronts/hearts_7.svg', 'fronts/hearts_8.svg', 'fronts/hearts_9.svg', 'fronts/hearts_10.svg',
    'fronts/hearts_ace.svg', 'fronts/hearts_jack.svg', 'fronts/hearts_king.svg', 'fronts/hearts_queen.svg', 'fronts/spades_2.svg',
    'fronts/spades_3.svg', 'fronts/spades_4.svg', 'fronts/spades_5.svg', 'fronts/spades_6.svg', 'fronts/spades_7.svg',
    'fronts/spades_8.svg', 'fronts/spades_9.svg', 'fronts/spades_10.svg', 'fronts/spades_ace.svg', 'fronts/spades_jack.svg',
    'fronts/spades_king.svg', 'fronts/spades_queen.svg', 'fronts/joker_black.svg', 'fronts/joker_red.svg'
];

let cardImages = [];
let columns = [[], [], []];
let step = 0;

function startGame() {
    document.getElementById('overlay').style.display = 'none';
    document.getElementById('instructions').style.display = 'block';
    shuffleAndDeal();
}

function shuffleAndDeal() {
    cardImages = [...allCardImages].sort(() => Math.random() - 0.5).slice(0, 21);
    dealCards();
}

function dealCards() {
    columns = [[], [], []];
    for (let i = 0; i < cardImages.length; i++) {
        columns[i % 3].push(cardImages[i]);
    }
    displayCards();
}

function displayCards() {
    document.getElementById('game').classList.add('dealing');
    for (let i = 0; i < 3; i++) {
        const column = document.getElementById(`column${i + 1}`);
        column.innerHTML = `<div class="column-label" onclick="columnSelected(${i})">${i + 1}</div>`;
        columns[i].forEach(card => {
            const img = document.createElement('img');
            img.src = card;
            img.className = 'card';
            column.appendChild(img);
        });
    }
    setTimeout(() => {
        document.getElementById('game').classList.remove('dealing');
    }, 500);
}

function columnSelected(pickedColumn) {
    nextStep(pickedColumn);
}

function nextStep(pickedColumn) {
    const newOrder = [];
    // Move picked column to the middle
    if (pickedColumn === 0) {
        newOrder.push(...columns[1], ...columns[0], ...columns[2]);
    } else if (pickedColumn === 1) {
        newOrder.push(...columns[0], ...columns[1], ...columns[2]);
    } else {
        newOrder.push(...columns[0], ...columns[2], ...columns[1]);
    }
    cardImages = newOrder;
    step++;
    if (step < 3) {
        dealCards();
    } else {
        revealFinalCard();
    }
}

function revealFinalCard() {
    const finalCardIndex = 10; // 11th card in the final pile
    const finalCardSrc = cardImages[finalCardIndex];
    const finalCardElement = document.getElementById('finalCard');
    const messageElement = document.getElementById('message');

    finalCardElement.src = finalCardSrc;
    finalCardElement.classList.add('show');
    messageElement.style.top = 'calc(50% + 175px)'; // Position message below the card
    messageElement.classList.add('show');

    setTimeout(() => {
        document.getElementById('playAgain').classList.add('show');
    }, 3000);
}

function playAgain() {
    document.getElementById('finalCard').classList.remove('show');
    document.getElementById('message').classList.remove('show');
    document.getElementById('playAgain').classList.remove('show');
    step = 0;
    shuffleAndDeal();
}

// Initial setup
document.getElementById('instructions').style.display = 'none';
